#include "Exception.h"

Exception::Exception(HRESULT hres, char const * error_message)
:_hres(hres), _error_message(error_message)
{

}

Exception::~Exception()
{

}


string const & Exception::get_error_message()
{
	return _error_message;
}

string Exception::get_human_hres()
{
	string result;
	if (FAILED (_hres))
	{
		if (HRESULT_FACILITY(_hres)==FACILITY_ITF && HRESULT_CODE(_hres)>0x200)
		{
			result=string("an exception has been raised in the COM object");
		}
		else
		{
			try //sometimes the functionm FormatMessage does not work...
			{
				char * msg;
				FormatMessage (
					FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
					0,
					_hres,
					MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT),
					reinterpret_cast<char *> (&msg),
					0,
					0);
				result=string(msg);
				LocalFree (msg);
			}
			catch (...)
			{}
		}
	}
	return result;
}

int Exception::get_error_code()
{
	if (FAILED (_hres) && HRESULT_FACILITY(_hres)==FACILITY_ITF && HRESULT_CODE(_hres)>0x200)
		return HRESULT_CODE(_hres)-0x0200;
	return 0;
}