#include "COM\db.h"

int main()
{
	int dummy=0;
	try
	{

		UseCOM mycominit;
		
		db mydb("my database");//a database is created
		
		mydb.new_table();//we create a new table...
		mydb.add_field("name", db_string);
		mydb.add_field("surname", db_string);
		mydb.add_field("age", db_int);
		mydb.commit_table("employee");
		
		mydb.new_record("employee");//we create a new record...
		mydb.set_field("name", "john");
		mydb.set_field("surname", "doe");
		mydb.set_field("age", (int) 12);
		mydb.commit_record();
		
		mydb.save_to_file("sample.xml");

		//to read a file created with quickdb and load it in a database:
		db otherdb("my database");
		//warning when reading a file:
		//you need to define the database structure:
		otherdb.new_table();//we create a new table...
		otherdb.add_field("name", db_string);
		otherdb.add_field("surname", db_string);
		otherdb.add_field("age", db_int);
		otherdb.commit_table("employee");

		otherdb.read_from_file("sample.xml");

		//other solution:
		//try to read it in an already existing database (which will be erased in case of an exception....
		mydb.read_from_file("sample.xml");
		
		printf ("everything went fine");
		return 0;
	}
	catch (Exception e)
	{
		printf(e.get_error_message().c_str());
		printf(e.get_human_hres().c_str());
		int error_code=e.get_error_code();
	}
	catch (...)
	{
		printf("unknown exception");
	}
}
